/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pe.siso.horario.Services;

import java.util.ArrayList;
import pe.siso.horario.Beans.Plana;
import pe.siso.horario.DAO.DAOFactory;
import pe.siso.horario.DAO.PlanaDAO;

/**
 *
 * @author sistem16user
 */
public class PlanaServices {

    DAOFactory fabrica = DAOFactory.getDAOFactory(DAOFactory.MYSQL);
    PlanaDAO objPlanaDAO = fabrica.getPlanaDAO();

    public ArrayList<Plana> listarPlana() {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.listarPlana();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Plana> listarPlanaAsiste(String codDocente,String codPer,String codArea) {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.listarPlanaAsiste(codDocente,codPer,codArea);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }

    public void cambiarEstado(String dato, String codigoPlana) {
        try {
            objPlanaDAO.cambiarEstado(dato, codigoPlana);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public void registrarPlana(String nombrePlana, String CodigoArea) {

        try {
            objPlanaDAO.registrarPlana(nombrePlana, CodigoArea);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public ArrayList<Plana> cargarPlana(String codigoArea) {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.cargarPlana(codigoArea);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Plana> cargarPlanaMatematica() {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.cargarPlanaMatematica();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Plana> cargarComunicacion() {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.cargarPlanaComunicacion();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Plana> cargarCiencias() {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.cargarPlanaCiencias();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Plana> cargarCTA() {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.cargarPlanaCTA();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }
    public ArrayList<Plana> cargarCEF() {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.cargarPlanaCEF();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }

    public ArrayList<Plana> listarPlana(String codigoArea) {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.listarPlana(codigoArea);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }

    public Plana NombrePlana(String codigoArea) {
        Plana plana = new Plana();

        try {
            plana = objPlanaDAO.NombrePlana(codigoArea);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return plana;
    }

    public ArrayList<Plana> Editar(String cod) {
        ArrayList<Plana> lista = null;
        try {
            lista = objPlanaDAO.Editar(cod);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return lista;
    }

    public void Actualizar(String codigoPlana, String nombre, String codigoArea, String color) {
        try {
            objPlanaDAO.Actualizar(codigoPlana, nombre, codigoArea, color);

        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public void registrarPlana(String nombrePlana, String CodigoArea, String color) {
        try {
            objPlanaDAO.registrarPlana(nombrePlana, CodigoArea, color);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public int cantidadUsoPlana(String codigoPlana) {
        int dato = 0;
        try {
            dato = objPlanaDAO.cantidadUsoPlana(codigoPlana);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return dato;
    }

    public int registrarPlanaDocente(String codigoPlana, String codigoDocente, String codigoPeriodo) {
        int dato = 0;
        try {
            dato = objPlanaDAO.registrarPlanaDocente(codigoPlana, codigoDocente, codigoPeriodo);
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return dato;
    }

}
